(function () {
    "use strict";

    angular.module('core').controller('clienteAtacadoDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$alert', '$q', '$state', '$stateParams', 'lookupService', 'empresaService', 'contatoService'];

    function controller($scope, $timeout, $alert, $q, $state, $stateParams, lookupService, empresaService, contatoService) {
        $scope.initializeLayout('Cliente Atacado');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false
        };
        $scope.popups = {
            contatos: { ativo: false },
            filiais: { ativo: false },
        };
        $scope.auxiliar = {
            estado: {
                data: [],
                args: {},
                getAll: function () {
                    lookupService
                        .getAllEstado($scope.auxiliar.estado.args)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    angular.copy(angular.fromJson(response.Data), $scope.auxiliar.estado.data);
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
            },
            endereco: {
                prepare: function (index) {
                    empresaService
                        .prepareEndereco($scope.state.item.Enderecos[index])
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                } else {
                                    $scope.state.item.Enderecos[index] = response.Data;
                                    $timeout(function () { $('#enderecos [ng-model$="item.Linha2"]').focus(); });
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
                prepareNew: function () {
                    empresaService
                        .prepareNewEndereco($scope.state.item)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                } else {
                                    $scope.state.item = response.Data;
                                    $timeout(function () { $('enderecos [ng-model$="item.Tipo"]').focus(); });
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
            },
            matriz: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            tipocliente: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTipoCliente({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            condicaopagamento: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllCondicaoPagamento({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            transpotadora: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTransportadora({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            empresa: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllEmpresa({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            tabelapreco: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTabelaPreco({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            representante: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllRepresentante({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            grupoFiscalEmpresa: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrupoFiscalEmpresa({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            gerente: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllVendedor({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            marca: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllMarca({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            contato: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllContato({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            contatos: { data: [], carregando: false, vazio: true, count: 0, args: { filtro: { Empresa: { ID: decodeURIComponent($stateParams.id) } }, skip: 0, take: 999999 } },
            filiais: { data: [], carregando: false, vazio: true, count: 0, args: { matrizID: decodeURIComponent($stateParams.id), skip: 0, take: 999999 } },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            empresaService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };

        $scope.getAllFilha = function () {
            $scope.auxiliar.filiais.carregando = true;
            $scope.auxiliar.filiais.vazio = false;
            empresaService
                .getAllFilha($scope.auxiliar.filiais.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.auxiliar.filiais.data);
                        }
                        $scope.auxiliar.filiais.carregando = false;
                        $scope.auxiliar.filiais.vazio = ($scope.auxiliar.filiais.data.length == 0);
                    },
                    function (_error) {
                        $scope.auxiliar.filiais.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getAllContato = function () {
            $scope.auxiliar.contatos.carregando = true;
            $scope.auxiliar.contatos.vazio = false;
            contatoService
                .getAll($scope.auxiliar.contatos.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            console.error(response.Exception);
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.auxiliar.contatos.data);
                        }
                        $scope.auxiliar.contatos.carregando = false;
                        $scope.auxiliar.contatos.vazio = !response.Data.length;
                    },
                    function (_error) {
                        $scope.auxiliar.contatos.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    });
        }

        $scope.save = function () {
            $scope.state.salvando = true;
            empresaService
                .save($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.state.salvando = false;
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            $scope.historyBack();
                        }
                    },
                    function (_error) {
                        $scope.state.salvando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    });
        };

        $scope.refresh = function () {
            $scope.get();
        };

        $scope.toggleContatos = function () {
            $scope.popups.contatos.ativo = !$scope.popups.contatos.ativo;
            if ($scope.popups.contatos.ativo)
                $scope.getAllContato();
        };
        $scope.toggleFiliais = function () {
            $scope.popups.filiais.ativo = !$scope.popups.filiais.ativo;
            if ($scope.popups.filiais.ativo)
                $scope.getAllFilha();
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();